Index: kernel/classes/packagehandlers/ezcontentclass/ezcontentclasspackagehandler.php
===================================================================
--- kernel/classes/packagehandlers/ezcontentclass/ezcontentclasspackagehandler.php	(revision 183)
+++ kernel/classes/packagehandlers/ezcontentclass/ezcontentclasspackagehandler.php	(working copy)
@@ -190,6 +190,10 @@
         }
         $classNameList->validate( );
 
+        $serializedDescriptionListNode = $content->getElementsByTagName( 'serialized-description-list' )->item( 0 );
+        $serializedDescriptionList = $serializedDescriptionListNode ? $serializedDescriptionListNode->textContent : false;
+        $classDescriptionList = new eZSerializedObjectNameList( $serializedDescriptionList );
+
         $classIdentifier = $content->getElementsByTagName( 'identifier' )->item( 0 )->textContent;
         $classRemoteID = $content->getElementsByTagName( 'remote-id' )->item( 0 )->textContent;
         $classObjectNamePattern = $content->getElementsByTagName( 'object-name-pattern' )->item( 0 )->textContent;
@@ -295,6 +299,7 @@
 
         $values = array( 'version' => 0,
                          'serialized_name_list' => $classNameList->serializeNames(),
+                         'serialized_description_list' => $classDescriptionList->serializeNames(),
                          'create_lang_if_not_exist' => true,
                          'identifier' => $classIdentifier,
                          'remote_id' => $classRemoteID,
@@ -367,6 +372,11 @@
             if ( $attributeSerializedNameList->isEmpty() )
                 $attributeSerializedNameList->initFromString( $classAttributeNode->getElementsByTagName( 'name' )->item( 0 )->textContent ); // for backward compatibility( <= 3.8 )
             $attributeSerializedNameList->validate( );
+            
+            $attributeSerializedDescriptionListNode = $classAttributeNode->getElementsByTagName( 'serialized-description-list' )->item( 0 );
+            $attributeSerializedDescriptionListContent = $attributeSerializedDescriptionListNode ? $attributeSerializedDescriptionListNode->textContent : false;
+            $attributeSerializedDescriptionList = new eZSerializedObjectNameList( $attributeSerializedDescriptionListContent );
+            
             $attributeIdentifier = $classAttributeNode->getElementsByTagName( 'identifier' )->item( 0 )->textContent;
             $attributePlacement = $classAttributeNode->getElementsByTagName( 'placement' )->item( 0 )->textContent;
             $attributeDatatypeParameterNode = $classAttributeNode->getElementsByTagName( 'datatype-parameters' )->item( 0 );
@@ -379,6 +389,7 @@
                                                                    array( 'version' => 0,
                                                                           'identifier' => $attributeIdentifier,
                                                                           'serialized_name_list' => $attributeSerializedNameList->serializeNames(),
+                                                                          'serialized_description_list' => $attributeSerializedDescriptionList->serializeNames(),
                                                                           'is_required' => $attributeIsRequired,
                                                                           'is_searchable' => $attributeIsSearchable,
                                                                           'is_information_collector' => $attributeIsInformationCollector,
@@ -552,6 +563,11 @@
         $identifierNode = $dom->createElement( 'identifier' );
         $identifierNode->appendChild( $dom->createTextNode( $class->attribute( 'identifier' ) ) );
         $classNode->appendChild( $identifierNode );
+        
+        $serializedDescriptionListNode = $dom->createElement( 'serialized-description-list' );
+        $serializedDescriptionListNode->appendChild( $dom->createTextNode( $class->attribute( 'serialized_description_list' ) ) );
+        $classNode->appendChild( $serializedDescriptionListNode );
+        
         $remoteIDNode = $dom->createElement( 'remote-id' );
         $remoteIDNode->appendChild( $dom->createTextNode( $class->attribute( 'remote_id' ) ) );
         $classNode->appendChild( $remoteIDNode );
@@ -672,6 +688,10 @@
             $attributeIdentifierNode->appendChild( $dom->createTextNode( $attribute->attribute( 'identifier' ) ) );
             $attributeNode->appendChild( $attributeIdentifierNode );
 
+            $attributeSerializedDescriptionListNode = $dom->createElement( 'serialized-description-list' );
+            $attributeSerializedDescriptionListNode->appendChild( $dom->createTextNode( $attribute->attribute( 'serialized_description_list' ) ) );
+            $attributeNode->appendChild( $attributeSerializedDescriptionListNode );
+
             $attributePlacementNode = $dom->createElement( 'placement' );
             $attributePlacementNode->appendChild( $dom->createTextNode( $attribute->attribute( 'placement' ) ) );
             $attributeNode->appendChild( $attributePlacementNode );