Index: bin/php/ezsessiongc.php
===================================================================
--- bin/php/ezsessiongc.php	(revision 0)
+++ bin/php/ezsessiongc.php	(revision 0)
@@ -0,0 +1,58 @@
+#!/usr/bin/env php
+<?php
+//
+// Created on: <21-Aug-2009 11:52:57 ar>
+//
+// ## BEGIN COPYRIGHT, LICENSE AND WARRANTY NOTICE ##
+// SOFTWARE NAME: eZ Publish
+// SOFTWARE RELEASE: 4.1.x
+// COPYRIGHT NOTICE: Copyright (C) 1999-2009 eZ Systems AS
+// SOFTWARE LICENSE: GNU General Public License v2.0
+// NOTICE: >
+//   This program is free software; you can redistribute it and/or
+//   modify it under the terms of version 2.0  of the GNU General
+//   Public License as published by the Free Software Foundation.
+//
+//   This program is distributed in the hope that it will be useful,
+//   but WITHOUT ANY WARRANTY; without even the implied warranty of
+//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//   GNU General Public License for more details.
+//
+//   You should have received a copy of version 2.0 of the GNU General
+//   Public License along with this program; if not, write to the Free
+//   Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+//   MA 02110-1301, USA.
+//
+//
+// ## END COPYRIGHT, LICENSE AND WARRANTY NOTICE ##
+//
+
+set_time_limit( 0 );
+$isQuiet = false;
+
+require 'autoload.php';
+
+$cli = eZCLI::instance();
+$script = eZScript::instance( array( 'description' => ( "eZ Publish Session Garbage Collector\n\n" .
+                                                        "Allows manual cleaning up expired sessions as defined by site.ini[Session]SessionTimeout\n" .
+                                                        "\n" .
+                                                        "./bin/php/ezsessiongc.php" ),
+                                     'use-session' => false,
+                                     'use-modules' => false,
+                                     'use-extensions' => false ) );
+
+$script->startup();
+
+$options = $script->getOptions( "",
+                                "[]",
+                                array() );
+$script->initialize();
+
+if ( !$isQuiet )
+    $cli->notice( "Cleaning up expired sessions." );
+
+eZSession::garbageCollector();
+
+$script->shutdown();
+
+?>

Property changes on: bin\php\ezsessiongc.php
___________________________________________________________________
Added: svn:eol-style
   + native

Index: cronjobs/session_gc.php
===================================================================
--- cronjobs/session_gc.php	(revision 0)
+++ cronjobs/session_gc.php	(revision 0)
@@ -0,0 +1,46 @@
+<?php
+//
+// Definition of Session_GC Cronjob
+//
+// Created on: <21-Aug-2009 11:44:49 ar>
+//
+// ## BEGIN COPYRIGHT, LICENSE AND WARRANTY NOTICE ##
+// SOFTWARE NAME: eZ Publish
+// SOFTWARE RELEASE: 4.1.x
+// COPYRIGHT NOTICE: Copyright (C) 1999-2009 eZ Systems AS
+// SOFTWARE LICENSE: GNU General Public License v2.0
+// NOTICE: >
+//   This program is free software; you can redistribute it and/or
+//   modify it under the terms of version 2.0  of the GNU General
+//   Public License as published by the Free Software Foundation.
+//
+//   This program is distributed in the hope that it will be useful,
+//   but WITHOUT ANY WARRANTY; without even the implied warranty of
+//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//   GNU General Public License for more details.
+//
+//   You should have received a copy of version 2.0 of the GNU General
+//   Public License along with this program; if not, write to the Free
+//   Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+//   MA 02110-1301, USA.
+//
+//
+// ## END COPYRIGHT, LICENSE AND WARRANTY NOTICE ##
+//
+
+/**
+ * Cronjob to garbage collect expired sessions as defined by site.ini[Session]SessionTimeout
+ * (the expiry time is calculated when session is created / updated)
+ * These are normally automatically removed by the session gc in php, but on some linux distroes
+ * based on debian this does not work because the custom way session gc is handled.
+ * 
+ * Also make sure you run basket_cleanup if you use the shop!
+ *
+ * @package eZCronjob
+ * @see eZsession
+ */
+
+
+eZSession::garbageCollector();
+
+?>

Property changes on: cronjobs\session_gc.php
___________________________________________________________________
Added: svn:eol-style
   + native